using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;

namespace Insight.Web.Pages.Management.Hosts.Systems.Users;

[Route(Navigation.Management.Hosts.Systems.Users.Details)]
public partial class Details
{
    [Parameter] public string? HostId { get; set; }
    [Parameter] public string? UserId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private HostUserEntity? HostUser { get; set; }

    private async Task LoadDataAsync()
    {
        Breadcrumbs.Clear();
        HostUser = null;

        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Users", href: Navigation.Management.Hosts.Systems.Users.IndexHref(HostId)));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(UserId) || ObjectId.TryParse(UserId, out var userId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.Users.IndexHref(HostId));
            return;
        }

        HostUser = await Database.HostSystemUser()
                .Find(p => p.Host == HostId && p.Id == UserId)
                .FirstOrDefaultAsync();

        if (HostUser is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.Users.IndexHref(HostId));
            return;
        }

        Title = $"Hosts » {host.Name} » User » {HostUser.Name}｜Insight";

        Breadcrumbs.Add(new BreadcrumbItem(HostUser.Name, href: "#", true));

        StateHasChanged();
    }
}